#!/usr/bin/env bash
workdir=$1
source $workdir/../multi-host.conf
testLog=$workdir/logs/hub_discovery.log

clean_up_nodeC() {
  r=$(sudo killall nfd 2>&1)
  sudo mv resolv.conf.bak /etc/resolv.conf
  sleep 2
}

mkdir -p $workdir/logs;
sudo nfd &> $workdir/logs/nfd.log &
sleep 2

####### TEST STAGE 3 #######

ndnsec-keygen /tmp/autoconfig-test | ndnsec-install-cert -
sudo cp /etc/resolv.conf resolv.conf.bak
echo "nameserver $IP4_A2" > resolv.conf
echo "search autoconfig-test-none.named-data.net" >> resolv.conf
sudo mv resolv.conf /etc/resolv.conf

sudo cat /etc/resolv.conf >> $testLog
echo "host ns1.autoconfig-test.tmp._homehub._autoconf.named-data.net." >> $testLog
host ns1.autoconfig-test.tmp._homehub._autoconf.named-data.net. >> $testLog

echo "ping -c 4 ns1.autoconfig-test.tmp._homehub._autoconf.named-data.net." >> $testLog
ping -c 4 ns1.autoconfig-test.tmp._homehub._autoconf.named-data.net. >> $testLog

ndn-autoconfig

sleep 3
# search output for 10.63.18.1, fail if  found
face=$(nfd-status -f | grep -F remote=udp4://10.63.18.1)
if [[ -n "$face" ]]; then
  clean_up_nodeC
  exit 1
fi

# search output for 10.63.18.2, fail if found.
face=$(nfd-status -f | grep -F remote=udp4://10.63.18.2)
if [[ -n "$face" ]]; then
  clean_up_nodeC
  exit 1
fi

#search output for 10.63.18.3, fail if not found.
face=$(nfd-status -f | grep -F remote=udp4://10.63.18.3)
if [[ -z "$face" ]]; then
  clean_up_nodeC
  exit 1
fi

clean_up_nodeC
exit 0
